<?php

# This program is distributed under the terms of the GNU General Public License.
# See the README & LICENSE files for more information.
# Copyright (C) 2001-2002  Kevin L. Papendick <kevinp@polarlava.com>

	########################
	### Build Table List ###
	########################
	$db_connect = mysql_pconnect($_SESSION['db_host'], $_SESSION['db_user'], $_SESSION['db_pw']);
	$table_query = 'SHOW TABLES';
	mysql_select_db($_SESSION['db_name']);
	$result = mysql_query($table_query);
	$db_err = mysql_error();

	if (!$result) {
		#####################
		### Display Error ###
		#####################
		$err_msg = "<b>
					Unable to retrieve table list data!<br>\n
					Query: $query_sent<br><br>\n
					<font color=\"$display_error_color\">DB Error: </font>
					&nbsp;&nbsp;$db_err<br></b>\n";
		unset($query_sent); //abort query if specified
	} else {
		$table_list = '<select name="table_name">\n';
		while ($row = mysql_fetch_array($result)) {
			$table_list .= "<option value=\"$row[0]\">$row[0]\n";
		}
		$table_list .= "</select>\n";
	}


	########################
	### Reset Query Form ###
	########################
	if ($reset) {
		unset($query_sent);
	}

	##################################
	### Save Query Display Windows ###
	##################################
	if (!$query_win_change) {
		if ($_SESSION['query_win_current'] == 1) {
			$_SESSION['query_win'][0] = $query_sent;
		} elseif ($_SESSION['query_win_current'] == 2) {
			$_SESSION['query_win'][1] = $query_sent;
		} elseif ($_SESSION['query_win_current'] == 3) {
			$_SESSION['query_win'][2] = $query_sent;
		}
	}
	############################
	### Change Query Windows ###
	############################
	if ($query_win_change) {
		$_SESSION['query_win_current'] = $query_win_change;
		$query_sent = $_SESSION['query_win'][$query_win_change - 1];
	}

	#########################
	### Manage Checkboxes ###
	#########################

	//--- Wrap Results Cells
	if ($wrap_results) {
		$wrap_checked = 'checked';
	} else {
		$wrap = 'nowrap';
		$wrap_checked = '';
	}

	//--- Display HTML Results
	if ($show_html) {
		$html_checked = 'checked';
	} else {
		$html_checked = '';
	}

	##########################
	### Display Query Form ###
	##########################
	$query_sent = stripslashes($query_sent); #translate escaped single quotes
	$display_qwc = $_SESSION['query_win_current'];
	$display_host = $_SESSION['db_host'];
	$display_db_name = $_SESSION['db_name'];
	$display_php_ver = $_SESSION['php_version'];
	$display_mysql_ver = $_SESSION['mysql_version'];

	print <<<FORM_BEG
			<form method="post" action="$PHP_SELF">
				<table border="0" align="center" width="90%" cellspacing="0" cellpadding="3">
					<tr>
						<td bgcolor="$display_hdr_bg" align="left" width="15%">
							&nbsp;<b>Interface:</b> <font size=\"+1\"><b>$display_qwc</b></font>
						</td>
						<td bgcolor="$display_hdr_bg" align="left" width="15%">
							<b>Host:</b> $display_host
						</td>
						<td bgcolor="$display_hdr_bg" align="left" width="30%">
							<b>Database:</b> $display_db_name
						</td>
						<td bgcolor="$display_hdr_bg" align="center" width="25%">
							<b>PHP:</b> $display_php_ver
						</td>
						<td bgcolor="$display_hdr_bg" align="center" width="45%">
							<b>MySQL:</b> $display_mysql_ver
						</td>
					</tr>
					<tr align="center">
						<td colspan="5">
							<textarea name="query_sent" rows="$display_query_rows" cols="$display_query_cols">$query_sent</textarea>
						</td>
					</tr>
					<tr>
						<td align="right" nowrap>
				        <input type="checkbox" name="wrap_results" $wrap_checked>Wrap Results&nbsp;&nbsp;
				        <br>
				        <input type="checkbox" name="show_html" $html_checked>Render HTML
						<td colspan="4" align="center" nowrap>
				        <input type="submit" name="submit" value="Execute Query">
				        &nbsp;&nbsp;<input type="submit" name="reset" value="New Query">
				        &nbsp;&nbsp;<input type="submit" name="save_query" value="Save Query">
				        &nbsp;&nbsp;<input type="submit" name="load_query" value="Load Query">
							&nbsp;&nbsp;<input type="submit" name="describe_table" value="Describe Table ->">
							$table_list
						</td>
					</tr>
				</table>
			</form>
			$menu

FORM_BEG;

	############################
	### Manage Query Request ###
	############################
	if ($describe_table) {
		$query = "DESCRIBE $table_name;";
		print "<b>DESCRIBE</b> <font color=\"$display_summary\">$table_name</font>:";
	} elseif ($query_win_change) {
		unset($query_win_change);
		unset($query);
	} elseif ($save_query) {
		#don't do anything!
 	} elseif ($new_query_loaded) {
 		unset($query);
 	} else {
		$query = $query_sent;
	}

	#######################
	### Process Queries ###
	#######################
	if ($query) {
		$query_list = array();

		### Pre-Process ###
		$query_tmp = preg_split("/\n/", $query); #breakout individual queries

		#process any lines that are not blank or commented out...
		foreach ($query_tmp as $query) {
			if (strlen($query) > 0 && (substr($query, 0, 1) == "#" || substr($query, 0, 2) == "--")) {
				#NOP - comment line
			} elseif (preg_match('/;\s*$/', $query)) {
				//space pad in case no space on left end of last line of multi-line query
				if (preg_match('/^\s+/', $query)) {
					$partial_query .= $query;
				} else {
					$partial_query .= " " . $query;
				}
				array_push($query_list, $partial_query);
				unset($partial_query);
			} else {
				#multi-line/partial query
				//space pad in case no space on left end of last line of multi-line query
				if (preg_match('/^\s+/', $query)) {
					$partial_query .= $query;
				} else {
					$partial_query .= " " . $query;
				}
			}
		}

		### Process Each Query ###
		foreach ($query_list as $query) {
			$query = chop($query);
			$query = ltrim($query);

			mysql_select_db($_SESSION['db_name']);
			$result = mysql_query($query);
			$db_err = mysql_error();
			if (!$result) {
				#####################
				### Display Error ###
				#####################
				$err_msg = "<b>
							Unable to retrieve table data!<br>\n
							Query: $query<br><br>\n
							<font color=\"$display_error_color\">DB Error: </font>
							&nbsp;&nbsp;$db_err<br></b>\n";
			}
			if ($result == 1) {
				$query_was_select = 0;
				$row_cnt = @mysql_affected_rows($db_connect);
			} else {
				$query_was_select = 1;
				$row_cnt = @mysql_num_rows($result);
			}
			#############################
			### Display Query Results ###
			#############################
			if ($query && !$err_msg && $query_was_select) {
				$display_data .= "<br>\n<table border=\"1\" cellspacing=\"0\" cellpadding=\"3\">\n";
				$row_color = 0;
				while ($row = mysql_fetch_array($result)) {
					### Table Header ###
					if (!$col_cnt) {
						$col_cnt = mysql_num_fields($result);
						$display_data .= "<tr bgcolor=\"$display_hdr_bg\">\n";
						for ($x = 0; $x < $col_cnt; $x++) {
							$col_name = mysql_field_name($result, $x);
							$display_data .= "<th>$col_name</th>\n";
						}
						$display_data .= "</tr>\n";
					}
		         ### Table Rows ###
					if ($row_color > 1) { $row_color = 0; }
					$display_data .= "<tr bgcolor=\"$display_row_bg[$row_color]\">\n";
					$row_color++;
					for ($x = 0; $x < $col_cnt; $x++) {
						if (is_null($row[$x])) {
							$display_data .= "\t<td>NULL</td>\n";
						} elseif (!$row[$x] && is_numeric($row[$x])) {
							$display_data .= "\t<td>0</td>\n";
						} elseif (!$row[$x]) {
							$display_data .= "\t<td>&nbsp;</td>\n";
						} else {
							//--- Replace HTML tags "<" & ">" with entities
							if (!$html_checked) {
								$row[$x] = str_replace('<', '&lt;', $row[$x]);
								$row[$x] = str_replace('>', '&gt;', $row[$x]);
							}

							//--- Save column data
							$display_data .= "\t<td $wrap>$row[$x]</td>\n";
						}
					}

					$display_data .= "</tr>\n";
				}
				print "$display_data</table>\n";
				if ($row_cnt >= 1) {
					print "<p><b><font color=\"$display_summary\">$row_cnt</font> rows in set</b></p>";
				} else {
					print "<p><b><font color=\"$display_summary\">Empty set</font></b></p>";
				}
			} elseif ($query && !$err_msg && !$query_was_select) {
				print "<p><b>Query OK, &nbsp;<font color=\"$display_summary\">$row_cnt</font> rows affected</b></p>";
			} elseif ($query && $err_msg) {
				#####################
				### Display Error ###
				#####################
				print "<p align=\"left\">
							<font color=\"$display_error_color\">
								<b>ERROR: </b>
							</font>
							<b>$err_msg</b>";
				unset($err_msg);
			}
			unset($display_data); //reset
			unset($col_cnt); //reset
		} //foreach
	} //if $query_sent
php?>