<?php

# This program is distributed under the terms of the GNU General Public License.
# See the README & LICENSE files for more information.
# Copyright (C) 2001-2002  Kevin L. Papendick <kevinp@polarlava.com>


###########################
### Database Connection ###
###########################
$db_name_default = '';
$db_user_default = '';
$db_host_default = 'localhost';
$db_port_default = '3306';

//--- Optional Picklist value
//$db_name_list = array('db_1', 'db_2', 'db_N');
//$db_user_list = array('user_1', 'user_2', 'user_N');

#######################
### General Options ###
#######################
$set_time_limit = 180;
$mode_default = 0; # 0 = SQL Interface, 1 = Table Dump
$session_save_path = '';
$session_timeout = 8;


##########################
### Table Dump Options ###
##########################
$default_delimiter = '"';
$default_separator = ',';


##########################
### Display Properties ###
##########################
$charset = 'iso-8859-1';
$display_query_cols = 90;
$display_query_rows = 10;
$display_page_bg = '#B3D9D9';
$display_hdr_bg = '#7E9AC7';
$display_row_bg = array('#CDC19C', '#E2E2C7');
$display_error_color = 'red';
$display_summary = 'red';


#############################
### Supplemental Programs ###
#############################
# PHPMyAdmin - MySQL Admin Program
# http://sourceforge.net/projects/phpmyadmin/
$pma_enable = 0;
$pma_location = '/path/to/phpMyAdmin/';
$pma_window = '_blank';

# phpMyDoc - Table Documenter
# http://sourceforge.net/projects/phpmydoc/
$pmd_enable = 0;
$pmd_location = '/path/to/phpMyDoc/';
$pmd_window = '_blank';

?>